package com.deplay.one.hybrid_example

import android.app.Activity
import android.app.Application
import com.deplay.one.hybrid.canvas.common.CanvasConfig
import com.deplay.one.hybrid.v8.V8Manager
import io.flutter.embedding.engine.FlutterEngine
import io.flutter.embedding.engine.FlutterEngineCache
import io.flutter.embedding.engine.dart.DartExecutor
import io.flutter.view.FlutterMain

class MFlutterApplication: Application() {
    private var mCurrentActivity: Activity? = null

    override fun onCreate() {
        super.onCreate()
        FlutterMain.startInitialization(this)
        setupFlutter()
        V8Manager.initV8(this)
        CanvasConfig.init(this);
    }

    fun getCurrentActivity(): Activity? {
        return this.mCurrentActivity
    }

    fun setCurrentActivity(mCurrentActivity: Activity) {
        this.mCurrentActivity = mCurrentActivity
    }

    fun setupFlutter(){
        val flutterEngine = FlutterEngine(this)
        // flutterEngine.settingsChannel.channel.send("/params")
        // flutterEngine.navigationChannel.setInitialRoute("/warmup")
        // flutterEngine.getNavigationChannel().setInitialRoute("/warmup");
        // Pre-warm your FlutterEngine by starting Dart execution.
        flutterEngine
                .getDartExecutor()
                .executeDartEntrypoint(
                        DartExecutor.DartEntrypoint.createDefault()
                )
        FlutterEngineCache.getInstance().put("my_engine_id", flutterEngine)
    }

}